/*
 * PasswordVector.java
 *
 * Copyright (C) 2005-2006 Tommi Laukkanen
 * http://www.substanceofcode.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.substanceofcode.saferoom.data;

import java.util.Enumeration;
import java.util.Hashtable;

/**
 *
 * @author Tommi Laukkanen
 */
public class PasswordGroupCollection {
    
    private Hashtable m_groups;
    
    /**
     * Creates a new instance of PasswordGroupCollection
     */
    public PasswordGroupCollection() {
        m_groups = new Hashtable();
    }
    
    /** Add an element */
    public void add(PasswordGroup item) {
        m_groups.put(item.getName(), item);
    }
    
    /** Remove an element at given index */
    public void remove(PasswordGroup item) {
	m_groups.remove(item.getName());
    }
    
    public String[] getNames() {
        String[] result = new String[ m_groups.size() ];
        Enumeration enumerator = m_groups.elements();
        int index = 0;
        while(enumerator.hasMoreElements()) {
            PasswordGroup item = (PasswordGroup) enumerator.nextElement();
            result[ index ] = item.getName();                
            index++;
        }
        return result;
    }    
    
    public Enumeration elements() {
        return m_groups.elements();
    }
    
    /** Return element at given position */
    public PasswordGroup getByName(String name) {
	return (PasswordGroup) m_groups.get(name);
    }
    
    /** Size */
    public int size() {
        return m_groups.size();
    }
    
}
